/*
    Copyright (C) 2006 Andrew Gaydenko <a@gaydenko.com>
    
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef QLCFG_H
#define QLCFG_H

#include <QtCore>
#include <QtXml/QDomDocument>

#include "QLE.h"
#include "IRInfo.h"
#include "ExcitCfg.h"

class QLCfg {

public:
    
    static const bool USE_PAHSE = true;
    static const int INDENT = 4;

    QLCfg(QString aPath);
    ~QLCfg();

    void appendIr(IRInfo info) throw (QLE);
    void removeIr(QString key) throw (QLE);
    void replaceIr(IRInfo info) throw (QLE);
    QString nextIrKey() throw (QLE);
    IRInfo getIr(const QString& key) throw (QLE);
    QList<IRInfo> getIrs() throw (QLE);
    
    void setExcit(const ExcitCfg&) throw (QLE);
    ExcitCfg getExcit() throw (QLE);

private:

    QString path;

    QString fileName();
    void initFile() throw (QLE);
    QDomDocument read() throw (QLE);
    void write(const QDomDocument&) throw (QLE);
    QString irKeyToString(int key) throw (QLE);
    bool fileExists() throw (QLE);
};

#endif
